<?
/*
*******************************
 IP-SYNCOM Event Scripting
*******************************
*/
//File: sFHTs.ips.php   BETA         : 1.00   date  14/09/12 Update to v2.5
//File: sFHTs.ips.php   PUBLIC       : 0.70   date  08/11/06
//File: sFHTs.ips.php   BETA VERSION : 0.69   date  04/11/06 '7' settings in .ini weekend bad interpret bug by Prof
//File: sFHTs.ips.php   BETA VERSION : 0.68   date  01/11/06 flank-detection problem due to TimerEvent and RunScript
//File: sFHTs.ips.php   BETA VERSION : 0.67   date  29/10/06 flank-detection doesn't work in S regime. bug by Torsteng
//File: sFHTs.ips.php   BETA VERSION : 0.66   date  18/06/06 Back to basic - no good
//File: sFHTs.ips.php   BETA VERSION : 0.65   date  18/06/06 semaphore test
//File: sFHTs.ips.php   BETA VERSION : 0.64   date  17/06/06 debug switch
//File: sFHTs.ips.php   PUBLIC       : 0.63   date  23/01/06
//
//Events : __imhome, __imaway, __party and all FHT_status-intervention variables
/*
Copyright rules applie under GNU-regulations
rest of copyright text ToDo
*/

include("43106.ips.php"); //"GlobaleDefines" - script
   /* variables needed in GlobalDefines.ips.php !!
      see "tempsettings.ini" and modifie to your environment /*
      
   /**********  USER SETTINGS  ***********************************************/

   $tempfilepath=__myhome."tempsettings.ini"; //default: 'tempsettings.ini'
   //              |---> defined in GlobalDefines.ips.php

   $use_imhome = true;
   // Note : A IPS variabele '__iamhome' should exist !!
      /* use this switch to overrule general settings
      the effect is that if IPS-variable "__imhome" = true
      the HOLIDAY temperature is sent as the result of
      this function
      !! ATTENTION  BETA WORK !!
      19/11/2005 :  I am not happy with how this implemented but it's a start
      19/09/2012 : Holiday is defined as a day where you'd normally be away and you are at home (I hope not sick)
      */

   $use_imaway = true;
   // Note : A IPS variabele '__iamaway' should exist !!
      /* use this switch to overrule general settings
      the effect is that if IPS-variable "__imaway" = true
      the AWAY temperature is sent as the result of
      this function
      !! ATTENTION  BETA WORK !!
      */

   $use_party = true;
   // Note : A IPS variabele '__party' should exist !!
      /* For all the party people out there ;-)
      Do YOU Like the Way YOU Feel when YOU Shake
      the effect is that if IPS-variable "__party" = true
      the party settings applie without checking days or dates.
      So starting on a Saturday will set party temperatures until
      you set __party=false on the Wednesday. (Oh my God what a party)
      */
   /**********  END OF USER SETTINGS  ****************************************/

   /**********  ADAPTATION TO YOUR ENVIROMENT  *******************************
   Every FHT has to have 2 variables with the names hereunder
   v(your-name)_soll : f.i. "vliv_temp_soll" = FHT soll temp in livingroom
   o(your-name)      : f.i. "oliv_temp" = device ID of the
                            FHT instance (set in GlobalDefines.ips.php)*/
	define("vliv_temp_soll", 27707);
	define("vliv_temp_state", 15835);
	define("vkeu_temp_soll", 58306);
	define("vkeu_temp_state", 47579);
	define("vbad_temp_soll", 53545);
	define("vbad_temp_state", 29882);
	define("vsl_temp_soll", 11651);
	define("vsl_temp_state", 29930);
	define("vslj_temp_soll", 26407);
	define("vslj_temp_state", 21686);
   /***********  END ADAPTATION  **********************************************/

   /**********  DEBUG SWITCHES  **********************************************/
   $softswitch = true; /*    Send the temp-settings to FHT or not
                             If you're debugging set it to false
                             so FHZ won't be overbuffered            */
   $use_sollwert = false;
   $sollwert = "19";      //is 'use_sollwert' = true then take this value

   // if you want a master-debug switch : create an IPS variabele "__debug"
   if (defined("__debug") && IPS_VariableExists(__debug)){
      $debug = GetValueBoolean(__debug);
   } else {
      $debug = false;   // set to true if you want to enable echo-output
   }
   /* logfilepath since we are dealing with variables which cannot be show in
      the direct output window.                                              */
   $logfilepath=__myhome."log\\tempSENT.txt";

//   $IPS_SENDER = "TimerEvent";

   /**********  END DEBUG  ***************************************************/

if ($_IPS["SENDER"] == "Designer"){
//do not run when event is triggered by designer
   exit;
}
if (defined("__fht_inhibit") && IPS_VariableExists(__fht_inhibit)){
   if (GetValueBoolean(__fht_inhibit)){
      if($debug) echo("INHIBITED by '__fht_inhibit'");
      exit();
   }
}
if ($_IPS["SENDER"] == "Variable"){
   /* Switch ONLY when __imaway becomes true or __imhome becomes true
      die if false -> script will be triggered in max 30 minutes.
      if settings change from imhome -> imaway, then FHZ buffer get's
      overbuffered because script did run 2 times
      imhome -> false, imaway -> true x 5 FHT-devices = buffer overrun */
   if ($_IPS["VARIABLE"] == __imaway && !GetValueBoolean(__imaway)) exit();
   // die when imhome = false
   if ($_IPS["VARIABLE"] == __imhome && !GetValueBoolean(__imhome)) exit();
   if ($_IPS["VARIABLE"] == __party && !GetValueBoolean(__party)) exit();
//*TD   $lastrun=IPS_GetLastRun("GetTemp");
$lastrun=time();
}
if (!file_exists("$tempfilepath")) {
   echo("\r\n\r\n******* ERROR: Please install '$tempfilepath'\r\n\r\n");
   die;
}
$handle=fopen("$tempfilepath", "r");
if (!$handle){
   // error cannot open file
   echo("******* ERROR: Cannot open file '$tempfilepath'\r\n");
}

//init variable
$aktor = array();
$conditions =  array();
$conditions["x"] = true;
$now = getdate();
$isholiday = false;
$isparty = false;
$holiday="";
$season = "";
$today="";
$alldays="";
$weekend="";
$imhome=false;
$party=false;
$temp_rule="";
if ($use_imhome && defined("__imhome") && IPS_VariableExists(__imhome)){
   $imhome = GetValueBoolean(__imhome);
} elseif ($use_imhome) {
   echo("\r\n\r\n******* NOTICE: Variabele '__imhome' not found as a valid IPS variabele\r\n\r\n");
   $imhome = false;
} else {
   $imhome = false;
}
if ($use_imaway && defined("__imaway") && IPS_VariableExists(__imaway)){
   $imaway = GetValueBoolean(__imaway);
} elseif ($use_imaway) {
   echo("\r\n\r\n******* NOTICE: Variabele '__imaway' not found as a valid IPS variabele\r\n\r\n");
   $imaway = false;
} else {
   $imaway = false;
}
if ($use_party && defined("__party") && IPS_VariableExists(__party)){
   $party = GetValueBoolean(__party);
} elseif ($use_party) {
   echo("\r\n\r\n******* NOTICE: Variabele '__party' not found as a valid IPS variabele\r\n\r\n");
   $party = false;
} else {
   $party = false;
}
// the serious work   start with settin' the inhibit switch so script won't be fired again until completion
SetValueBoolean(__fht_inhibit,true);
// if script has been fired through the 'special' variables reset them ...
if ($_IPS["SENDER"]=="Variable"){
	if (GetValueBoolean(__imhome)){
	   // reset others
	   SetValueBoolean(__imaway, false);
	   // does it have to be reset? maybe for next time SetValueBoolean(__party, false);
	} elseif (GetValueBoolean(__imaway)){
	   SetValueBoolean(__imhome, false);
	   SetValueBoolean(__party, false);
	} elseif (GetValueBoolean(__party)){
	   SetValueBoolean(__imaway, false);
	}
}

while(!feof($handle)) {
   $buffer = fgets($handle);
   Switch (substr($buffer,0,1)) {
   case "@":
      //general settings
      if (substr($buffer,1,7) == "season=") {
         $season = substr($buffer,8,1);
      }
      if (substr($buffer,1,1) == "H") {
         if ((sprintf("%02d",$now["mon"])."/".sprintf("%02d",$now["mday"]) == substr($buffer,2,5)) or (sprintf("%02d",$now["mon"])."/".sprintf("%02d",$now["mday"])."/".$now["year"] == substr($buffer,2,10))) {
            $isholiday = true;
            $temp_rule = substr($buffer,strpos($buffer,"#")+1,strlen($buffer)-strpos($buffer,"#")-3);
            if ($debug) echo "temp rule : $temp_rule";
         }
      }
      break;
   case "D":
      //DEFAULT lines
      $condition=(substr($buffer,19,1));
      if (substr($buffer,1,1) == "$season" && chop(substr($buffer,4,14))=="default"){
          // get default default or default room
          // aktor("default" -> $default OR "room" -> $default)
          $default = substr($buffer,27,48);
      } elseif (substr($buffer,1,1) == "$season") {
         $aktor[chop(substr($buffer,4,14))][$condition]["default"] = substr($buffer,27,48);
      }
      break;
   case "H":
      //HOLIDAY table entries
      $condition=(substr($buffer,19,1));
      if ($isholiday) {
         // NOTE THEM DOWN IN array[aktor,["holiday"]
         if (substr($buffer,1,1) == "$season") $aktor[chop(substr($buffer,4,14))][$condition]["holiday"]= substr($buffer,27,48);
      } else {
         if (substr($buffer,1,1) == "$season") $aktor[chop(substr($buffer,4,14))][$condition]["iamhome"]= substr($buffer,27,48);
      }
      break;
   case "I":
      //Table entries
      $condition=(substr($buffer,19,1));
      if ((substr($buffer,1,1) == "$season") and (substr($buffer,2,1) == "9")) $aktor[chop(substr($buffer,4,14))][$condition]["alldays"] = substr($buffer,27,48);
      if ((substr($buffer,1,1) == "$season") and (substr($buffer,2,1) == "7") and (($now["wday"] == 0) or ($now["wday"] == 6))) $aktor[chop(substr($buffer,4,14))][$condition]["weekend"] = substr($buffer,27,48);
      if ((substr($buffer,1,1) == "$season") and (substr($buffer,2,1) == $now["wday"])) $aktor[chop(substr($buffer,4,14))][$condition]["today"]= substr($buffer,27,48);
		break;
   case "W":
      // IamAway settings
      $condition=(substr($buffer,19,1));
      if (substr($buffer,1,1) == "$season" && chop(substr($buffer,4,14))=="default"){
          // get default default or default room
          // aktor("default" -> $default OR "room" -> $default)
          if ($imaway) $default = substr($buffer,27,48);
      }
      break;
   case "P":
      // PaAaRtY settings
      // no date-jump will occure !!
      // tryout 26/11/2005
      $condition=(substr($buffer,19,1));
      if (substr($buffer,1,1) == "$season") $aktor[chop(substr($buffer,4,14))][$condition]["party"]= substr($buffer,27,48);
      break;
	case "C":
	   // Conditions ...
		@trigger_error("");
		$thiscondition = chop(substr($buffer,3));
		$parseresult = eval($thiscondition);
		$parseerror = error_get_last();
		$pos = strpos($parseerror["message"], "PHP Parse error");
		if ($pos === 0) {
		   echo "Parse error in condition ". substr($buffer,2,1) . "in tempsettings.ini !!!!".PHP_EOL."Please review ' $thiscondition'".PHP_EOL;
		}
	   $conditions[substr($buffer,1,1)] = $parseresult;
	   break;
   default:
      //only thing to expect are comments '#' and temp settings
      // PUT IN ARRAY !!! WE NEED THEM LATER
      // USE array[sign => value]
      if (substr($buffer,0,1) <> "#") {
         $temp[substr($buffer,0,1)] = substr($buffer,1,5);
      }
   }
}
$temp["0"]=false;
$temp["1"]=true;
fclose($handle);

if ($debug) {
	foreach($aktor as $key => $aktcond){
   foreach($aktcond as $cond => $value){
      $thisday = $now["wday"];
      if ($debug) echo("RESULT for '$key' and CONDITION '$cond'".PHP_EOL."---------------------------------".PHP_EOL);
      if ($debug) echo("  now             :'". $now["hours"] .":". $now["minutes"] . PHP_EOL);
      if ($debug) echo("  today is nr#    : $thisday".PHP_EOL);
      if ($debug) echo("  season          : $season".PHP_EOL);
      if ($debug) echo("  Is it a holiday : $isholiday".PHP_EOL);
      if ($debug) echo("  Check precendence hereunder".PHP_EOL);
      if ($debug) echo("  Am I home ?     : $imhome".PHP_EOL);
      if(array_key_exists("iamhome",$value) && $debug)echo("  IAmHome         : ".$aktor[$key][$cond]["iamhome"].PHP_EOL);
      if ($debug) echo("  Am I away ?     : $imaway" .PHP_EOL);
      if(array_key_exists("iamaway",$value) && $debug)echo("  IAmAway         : ".$aktor[$key][$cond]["iamaway"].PHP_EOL);
      if(array_key_exists("holiday",$value) && $debug)echo("  holiday         : ".$aktor[$key][$cond]["holiday"].PHP_EOL);
      if ($debug) echo("  Paaaartyy ?     : $party".PHP_EOL);
      if(array_key_exists("party",$value) && $debug)echo("  Party           : ".$aktor[$key][$cond]["party"].PHP_EOL);
      if(array_key_exists("today",$value) && $debug)echo("  today           : ".$aktor[$key][$cond]["today"].PHP_EOL);
      if(array_key_exists("weekend",$value) && $debug)echo("  weekends        : ".$value["weekend"].PHP_EOL);
      if(array_key_exists("alldays",$value) && $debug)echo("  alldays         : ".$aktor[$key][$cond]["alldays"].PHP_EOL);
      if(array_key_exists("default",$value) && $debug)echo("  default rule    : ".$aktor[$key][$cond]["default"].PHP_EOL);
      if ($debug) echo("  def. def. rule  : $default".PHP_EOL);
      if ($debug) echo("--------------------  END  ------------------------".PHP_EOL);
   } //for
	} // for $cond
} //if
/* precendence rules
   ON ALL ELEMENTS OF ARRAY = Aktors
   VARIABLES = FIELDS OF ARRAY ("AKTOR" [ROOMDEFAULT, HRule, DayRULE, RESULT, soll)
   NEGATIVE LOGIC    Variables are filled in IF applicable */
if ($debug) echo PHP_EOL.PHP_EOL;
foreach($aktor as $key => $condakt){
foreach($condakt as $cond => $value){
	if ($conditions[$cond]) { //result of the eval rule
   if (!array_key_exists("holiday", $value)) {
      if (!array_key_exists("today", $value)) {
         if (!array_key_exists("weekend", $value)) {
            if (!array_key_exists("alldays", $value)) {
               if (!array_key_exists("default", $value)) {
                  $aktor[$key][$cond]["result"] = $default;
                  if ($debug) echo "res = def. def";
               } else {
                  $aktor[$key][$cond]["result"] = $value["default"];
                  if ($debug) echo "res = default";
               } // if
            } else {
               $aktor[$key][$cond]["result"] = $value["alldays"];
               if ($debug) echo "res = alldays";
            }
         } else {
            $aktor[$key][$cond]["result"] = $value["weekend"];
            if ($debug) echo "res = weekend";
         }
      } else {
         $aktor[$key][$cond]["result"] = $value["today"];
         if ($debug) echo "res = today";
      }
   } else {
      $aktor[$key][$cond]["result"] = $value["holiday"];
      if ($debug) echo "res = holiday";
   }
   // attempt to set IAmHome rule !!
   if ($use_imhome and $imhome) {
      if (array_key_exists("iamhome", $value)){
         $aktor[$key][$cond]["result"] = $value["iamhome"];
         if ($debug) echo PHP_EOL."OVERRULED RESULT set to HOLIDAY because I AM HOME".PHP_EOL;
      }
   }
   // attemp to set Away-rule
   if ($use_imaway and $imaway) {
      $aktor[$key][$cond]["result"] = $default;
      if ($debug) echo (PHP_EOL."OVERRULED RESULT set to AWAY".PHP_EOL);
   }
   // attempt to set Party rule !!
   if ($use_party and $party) {
      if (array_key_exists("party", $value)){
         $aktor[$key][$cond]["result"] = $value["party"];
         if ($debug) echo PHP_EOL."OVERRULED RESULT set to PaAaRrTYyyyy".PHP_EOL;
      }
   }
   if ($debug) echo(PHP_EOL."For '$key' I did choose    : '".$aktor[$key][$cond]["result"].PHP_EOL);
   } // end if $cond
}
} //end for $cond
// here we get the temperature out of string
// USE ARRAY["AKTOR", "soll"]
// change 11/10/2005 'floor' into 'round' because otherwise allways back to ??h00 instead of ??h00 or ??h30
$pos = $now["hours"]*2 + round($now["minutes"]/30);
$prevpos = $pos - 1;
if ($debug) echo("hours: " . $now["hours"] . " hours *2 = " . $now["hours"]*2 . "round($now[minutes]/30) = " . (round($now["minutes"]/30) . PHP_EOL));
if ($debug) echo "pos = '$pos'  (check midnight !!".PHP_EOL;
// end change
foreach($aktor as $key => $condakt){
foreach($condakt as $cond => $value){
	if ($conditions[$cond]) { //result of the eval rule
   $aktor[$key][$cond]["soll"] = $temp[substr($value["result"],$pos,1)];
   if ($debug) echo "res  : '" . $value["result"]."  $key".PHP_EOL;
   if ($debug) echo "time : '123456789012345678901234567890123456789012345678'".PHP_EOL;
   if ($debug) echo "$key uses now temp = '" . $aktor[$key][$cond]["soll"].PHP_EOL;
   } // end if $cond
}
} //end for $cond

// and now deal with the state-event.
// detect flanks
//if ($temp[substr($value["result"],$pos,1)] <> $temp[substr($value["result"],$pos,1)]){

// 11/10/2005 This is still a burdon !! damn boy ... where do you wanne drive the MIN-TEMP to ? and MAX-TEMP ?
//if ($use_imhome and $imhome) {
//   $soll = $temp["+"];
//   $status = "OVERRULED  set to";
//} elseif ($use_imhome) {
//   $soll = $temp["-"];
//   $status = "OVERRULED  set to";
//} else {
//   $status = substr($result,$pos,1)."     : ";
//}
// 19/11/2005 : decided when 'I am Home' is selected to choose 'holiday'-rule

$handle = fopen("$logfilepath","a");
$neg = "NOT (SSw)";
if ($softswitch) $neg = "";

// GET ALL AKTORS OUT OF ARRAY["AKTOR","SOLL"] = nice result of all the -above- work
// loop here : for every aktor in array : setTemp(Aktor, argument);
$junk = 1;
foreach($aktor as $key => $condakt){
foreach($condakt as $cond => $value){
	if ($conditions[$cond]) { //result of the eval rule
   if ($use_sollwert) {
      echo("OVERRULED BY use_sollwert");
      $value["soll"]= $sollwert;
   }
   $thissoll=$key."_soll";
	if (!defined($thissoll)) {
	   echo(PHP_EOL.PHP_EOL."******* NOTICE: 'soll'-variable ($thissoll) not defined in GlobalDefines.ips.php".PHP_EOL.PHP_EOL);
	} else {
		SetValueFloat(constant($thissoll),floatval($value["soll"]));
	}
	$thisstate=$key."_state";
	if (!defined($thisstate)) {
	   echo(PHP_EOL.PHP_EOL."******* NOTICE: 'state'-variable ($thisstate) not defined in GlobalDefines.ips.php".PHP_EOL.PHP_EOL);
	} else {

	}

   if ($debug) echo("FHT temp for '$key"."_soll' set to '".$value["soll"]."' !!".PHP_EOL);
   // as the result of the function set aktors to soll
   $thisinstance = "o" . substr($key,1);
   if (!defined($thisinstance)) {
      echo(PHP_EOL.PHP_EOL."******* NOTICE: FHT-ID ($thisinstance) not defined in GlobalDefines.ips.php".PHP_EOL.PHP_EOL);
   } elseif (!IPS_ObjectExists(constant($thisinstance))) {
      echo(PHP_EOL.PHP_EOL."******* NOTICE: FHT with ID '". constant($thisinstance) . "' is not a valid instance in IPS.".PHP_EOL.PHP_EOL);
   } else {
      if ($_IPS["SENDER"] == "Variable") {
         if ($_IPS["VARIABLE"] == "__imhome" || $_IPS["VARIABLE"] == "__imaway" || $_IPS["VARIABLE"] == "__party"){
            if ($softswitch) FHT_SetTemperature(constant($thisinstance),floatval($value["soll"]));
            if ($debug) echo("FHT_SetTemp for $thisinstance $neg SENT due to '$IPS_VARIABLE'-trigger".PHP_EOL);
            if ($debug) fwrite($handle, date("d.m.y")."  ". date("H:i:s")."  $IPS_SENDER  - FHT_SetTemp ". $value["soll"]. "C for $thisinstance $neg SENT due to '$IPS_VARIABLE'-trigger".PHP_EOL);
         } else {

            if ($debug) fwrite($handle,  date("d.m.y")."  ". date("H:i:s")."  $IPS_SENDER  - $thisinstance is set EXTERNALLY to " . GetValueFloat(constant($thisstate)) . "C due to '".$_IPS["VARIABLE"]."'-trigger (no value sent... logging only".PHP_EOL);
         }
      } elseif ($_IPS["SENDER"] == "TimerEvent") {
         // only set soll-temp if there are changes required (flank-detection) to reset manual intervention
         if ($debug) echo("Trigger : timerevent, Is '" . $temp[substr($value["result"],$pos,1)] . "' = '" . $temp[substr($value["result"],$prevpos,1)] . "' ?".PHP_EOL);
         if ($temp[substr($value["result"],$pos,1)] <> $temp[substr($value["result"],$prevpos,1)]){
            //flank detected
            if ($softswitch) FHT_SetTemperature(constant($thisinstance),floatval($value["soll"]));
            if ($debug) echo("FHT_SetTemp for $thisinstance $neg SENT due to change of setting (flank detection).".PHP_EOL);
            if ($debug) fwrite($handle, date("d.m.y")."  ". date("H:i:s")."  ".$_IPS["SENDER"]."  - sFHT_SetTemp ". $value["soll"]. "C for $thisinstance $neg SENT due to change of setting (flank detection).".PHP_EOL);
         } else {
            if ($debug) fwrite($handle, date("d.m.y")."  ". date("H:i:s")."  ".$_IPS["SENDER"]."  - No flank detected for $thisinstance.".PHP_EOL);
         }
      } elseif ($_IPS["SENDER"] == "Execute") {
         //manual exec.
         if ($softswitch) FHT_SetTemperature(constant($thisinstance),floatval($value["soll"]));
         if ($debug) echo("FHT_SetTemp for $thisinstance $neg SENT due to manual-exec.".PHP_EOL);
         if ($debug) fwrite($handle, date("d.m.y")."  ". date("H:i:s")."  ".$_IPS["SENDER"]."/MANUAL - sFHT_SetTemp ". $value["soll"]. "C for $thisinstance $neg SENT due to manual-exec.".PHP_EOL);
      } else {
         //script fired by???
         if ($softswitch) FHT_SetTemperature(constant($thisinstance),floatval($value["soll"]));
         if ($debug) echo("Script has been fired through: ".$_IPS["SENDER"] . " -> FHT_SetTemp for $thisinstance $neg SENT.".PHP_EOL);
         if ($debug) fwrite($handle, date("d.m.y")."  ". date("H:i:s")."  ".$_IPS["SENDER"]." - sFHT_SetTemp ". $value["soll"]. "C for $thisinstance $neg SENT.".PHP_EOL);
		}
   }
   }// end if $cond
   
   // ugly way to handle FHZ buffer issues
   // should be done by multiple passes so max 6 commands every 6 minutes
   // multiple passes ToDo
   // Paresy talked about a FHT1000 buffer; maybe there is a way to deal with this??

   // removed in version: 0.66 FHT-buffer now in place
   //if (bcmod($junk, 6) == 0) IPS_Sleep(1000*10); // wait 10 seconds FHZbuffer !!;
   //$junk += 1;
}
} //  end for $cond
// 2006/05/30 modifie due to multi-hreads
SetValueBoolean(__fht_inhibit,false);
// 2006/05/30 end modifie
if ($debug) echo("Finished".PHP_EOL);
if ($debug) fclose($handle);
?>
